import '@mescius/wijmo.styles/wijmo.css';
import './styles.css';
//
import { isIE } from '@mescius/wijmo';
import * as wjInput from '@mescius/wijmo.input';
import * as wjChart from '@mescius/wijmo.chart';
import { ChartGestures, InteractiveAxes, MouseAction } from '@mescius/wijmo.chart.interaction';
import { WebGLRenderEngine } from '@mescius/wijmo.chart.webgl';
import { getData } from './data';
document.readyState === 'complete' ? init() : window.onload = init;
function init() {
let chart = new wjChart.FlexChart('#theChart', {
chartType: 'Scatter',
bindingX: 'x',
binding: 'y',
axisX: { min: -2, max: 2 },
axisY: { min: -2, max: 2, axisLine: true, majorGrid: false },
});
// add interaction
let chartGestures = new ChartGestures(chart, {
interactiveAxes: InteractiveAxes.XY,
mouseAction: MouseAction.Zoom,
scaleY: 1,
posY: 0.5,
scaleX: 1,
posX: 0.5
});
//
// chart data helper
const refreshData = () => {
if (nSerMenu && nPtsMenu && symMenu) {
const nser = nSerMenu.selectedValue;
const npts = nPtsMenu.selectedValue;
const marker = symMenu.selectedValue;
chart.beginUpdate();
chart.series.length = 0;
for (let i = 0; i < nser; i++) {
let series = new wjChart.Series();
series.name = `ser ${i + 1}`;
series.symbolStyle = { strokeWidth: 0 };
series.symbolMarker = marker;
series.itemsSource = getData(Math.random() - 0.5, Math.random() - 0.5, npts / nser, 0.5 * (1 - i / nser));
chart.series.push(series);
}
chart.endUpdate();
}
};
//
// menu header helper
const updateMenuHeader = (menu, header) => {
menu.header = header ? `${header}: <b>${menu.text}</b>` : menu.text;
};
//
// number of points menu
const nPtsMenu = new wjInput.Menu('#nPtsMenu', {
selectedIndex: isIE() ? 1 : 2,
itemClicked: (s) => {
updateMenuHeader(s, 'NumPoints');
refreshData();
}
});
nPtsMenu.onItemClicked();
//
// number of series menu
let nSerMenu = new wjInput.Menu('#nSerMenu', {
itemClicked: (s) => {
updateMenuHeader(s, 'NumSeries');
refreshData();
}
});
nSerMenu.onItemClicked();
//
// series symbol menu
let symMenu = new wjInput.Menu('#symbolMenu', {
itemClicked: (s) => {
// const marker = parseInt(s.selectedValue);
const marker = s.selectedValue;
chart.series.forEach((ser) => ser.symbolMarker = marker);
updateMenuHeader(s, 'Symbol');
}
});
symMenu.onItemClicked();
//
// serias symbol size menu
let symSize = new wjInput.Menu('#symbolSize', {
itemClicked: (s) => {
chart.symbolSize = parseInt(s.selectedValue);
updateMenuHeader(s, 'Size');
}
});
symSize.onItemClicked();
//
// render engine to use
const webjlEl = document.getElementById('webgl');
const webglEng = new WebGLRenderEngine();
const svgEng = new wjChart.SvgRenderEngine();
const updateRenderEngin = () => {
chart.renderEngine = webjlEl.checked ? webglEng : svgEng;
};
webjlEl.addEventListener('click', updateRenderEngin);
updateRenderEngin();
//
// refresh data button
document.getElementById('btnNew').addEventListener('click', refreshData);
//
// reset zoom button
document.getElementById('btnReset').addEventListener('click', () => chartGestures.reset());
//
if (isIE()) {
nPtsMenu.itemsSource.pop();
nPtsMenu.itemsSource.pop();
}
// initialize data
refreshData();
}
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>WebGL</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- SystemJS -->
<script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.21.5/system.src.js" integrity="sha512-skZbMyvYdNoZfLmiGn5ii6KmklM82rYX2uWctBhzaXPxJgiv4XBwJnFGr5k8s+6tE1pcR1nuTKghozJHyzMcoA==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('./src/app');
</script>
</head>
<body>
<div class='container-fluid'>
<div class="row">
<div class="col-sm-12">
<select id="nPtsMenu">
<option value="1000">1K</option>
<option value="10000">10K</option>
<option value="100000" selected="selected">100K</option>
<option value="200000">200K</option>
<option value="500000">500K</option>
</select>
<select id="nSerMenu">
<option value="1" selected="selected">1</option>
<option value="2">2</option>
<option value="4">4</option>
<option value="8">8</option>
</select>
<select id="symbolMenu">
<option value="Dot" selected="selected">Dot</option>
<option value="Box">Box</option>
</select>
<select id="symbolSize">
<option value="3" selected="selected">3</option>
<option value="5">5</option>
<option value="10">10</option>
<option value="20">20</option>
<option value="50">50</option>
</select>
<label>
Use WebGL
<input id="webgl" type="checkbox" checked="checked">
</label>
</div>
</div>
<div class="row">
<div class="col-sm-12">
<div id="theChart"></div>
</div>
</div>
<div class="row">
<div class="col-sm-12">
<button id="btnNew">Refresh Data</button>
<button id="btnReset">Reset Zoom</button>
</div>
</div>
</div>
</body>
</html>
export function getData(cx, cy, n, maxr) {
let data = new Array(n);
let r0 = 0.1 + maxr;
for (let i = 0; i < data.length; i++) {
let a = 2 * Math.PI * Math.random();
let r = r0 * Math.sqrt(-2 * Math.log(Math.random()));
data[i] = {
x: cx + r * Math.cos(a),
y: cy + r * Math.sin(a)
};
}
return data;
}
.wj-flexchart {
width: 600px;
height: 500px;
margin: 0;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'jszip': 'npm:jszip/dist/jszip.js',
'@mescius/wijmo': 'npm:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'npm:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'npm:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'npm:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'npm:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'npm:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'npm:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'npm:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'npm:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'npm:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'npm:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'npm:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'npm:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'npm:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'npm:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'npm:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'npm:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'npm:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'npm:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'npm:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'npm:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.grouppanel': 'npm:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'npm:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'npm:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'npm:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'npm:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'npm:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'npm:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'npm:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'npm:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.nav': 'npm:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'npm:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'npm:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'npm:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'npm:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'npm:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'npm:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'npm:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'npm:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'npm:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.touch': 'npm:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'npm:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.barcode': 'npm:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'npm:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'npm:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'npm:@mescius/wijmo.barcode.specialized/index.js',
'jszip': 'npm:jszip/dist/jszip.js',
'bootstrap.css': 'npm:bootstrap/dist/css/bootstrap.min.css',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);

<template>
<div class="container-fluid">
<div class="row">
<div class="col-sm-12">
<wj-menu header="NumPoints" :value="numberOfPoints" :itemClicked="numPointsChanged">
<wj-menu-item :value="1000">1K</wj-menu-item>
<wj-menu-item :value="10000">10K</wj-menu-item>
<wj-menu-item :value="100000">100K</wj-menu-item>
<wj-menu-item v-if="notIE" :value="200000">200K</wj-menu-item>
<wj-menu-item v-if="notIE" :value="500000">500K</wj-menu-item>
</wj-menu>
<wj-menu header="NumSeries" :value="numberOfSeries" :itemClicked="numSeriesChanged">
<wj-menu-item :value="1">1</wj-menu-item>
<wj-menu-item :value="2">2</wj-menu-item>
<wj-menu-item :value="4">4</wj-menu-item>
<wj-menu-item :value="8">8</wj-menu-item>
</wj-menu>
<wj-menu header="Symbol" :value="seriesSymbol" :itemClicked="symbolChanged">
<wj-menu-item :value="'Dot'">Dot</wj-menu-item>
<wj-menu-item :value="'Box'">Box</wj-menu-item>
</wj-menu>
<wj-menu header="Size" :value="symbolSize" :itemClicked="sizeChanged">
<wj-menu-item :value="3">3</wj-menu-item>
<wj-menu-item :value="5">5</wj-menu-item>
<wj-menu-item :value="10">10</wj-menu-item>
<wj-menu-item :value="20">20</wj-menu-item>
<wj-menu-item :value="50">50</wj-menu-item>
</wj-menu>
<label>
Use WebGL
<input id="webgl" type="checkbox" v-model="useWebGL" />
</label>
</div>
</div>
<div class="row">
<div class="col-sm-12">
<wj-flex-chart :initialized="initialize" :renderEngine="renderEngine" chartType="Scatter" bindingX="x"
binding="y" :symbolSize="symbolSize">
<wj-flex-chart-axis wjProperty="axisX" :min="-2" :max="2" />
<wj-flex-chart-axis wjProperty="axisY" :min="-2" :max="2" :axisLine="true" :majorGrid="false" />
<wj-flex-chart-gestures interactiveAxes="XY" mouseAction="Zoom" :initialized="gesturesInitialized"
:scaleY="1" :posY="0.5" :scaleX="1" :posX="0.5" />
</wj-flex-chart>
</div>
</div>
<div class="row">
<div class="col-sm-12">
<button id="btnNew" @click="refreshData">Refresh Data</button>
<button id="btnReset" @click="resetZoom">Reset Zoom</button>
</div>
</div>
</div>
</template>
<script setup>
import { isIE } from "@mescius/wijmo";
import * as wjChart from "@mescius/wijmo.chart";
import { WebGLRenderEngine } from "@mescius/wijmo.chart.webgl";
import { getData } from "./data";
import { ref, onMounted, computed } from "vue";
const numberOfPoints = ref(isIE() ? 10000 : 100000);
const numberOfSeries = ref(1);
const seriesSymbol = ref("Dot");
const symbolSize = ref(3);
const useWebGL = ref(true);
const webglEng = new WebGLRenderEngine();
const svgEng = new wjChart.SvgRenderEngine();
const theChart = ref(null);
const gestures = ref(null);
const renderEngine = computed(() => useWebGL.value ? webglEng : svgEng);
onMounted(function () {
refreshData();
});
function initialize(chartref) {
theChart.value = chartref;
}
function numPointsChanged(s) {
numberOfPoints.value = s.selectedValue;
refreshData();
}
function numSeriesChanged(s) {
numberOfSeries.value = s.selectedValue;
refreshData();
}
function symbolChanged(s) {
seriesSymbol.value = s.selectedValue;
let chart = theChart.value;
chart.beginUpdate();
chart.series.forEach((s) => (s.symbolMarker = seriesSymbol.value));
chart.endUpdate();
}
function sizeChanged(s) {
symbolSize.value = s.selectedValue;
let chart = theChart.value;
chart.beginUpdate();
chart.series.forEach((s) => (s.symbolSize = symbolSize.value));
chart.endUpdate();
}
function refreshData() {
const data = [];
const nser = numberOfSeries.value;
const npts = numberOfPoints.value;
const chart = theChart.value;
chart.beginUpdate();
chart.series.clear();
for (let i = 0; i < nser; i++) {
chart.series.push(
new wjChart.Series({
itemsSource: getData(Math.random() - 0.5, Math.random() - 0.5, npts / nser, 0.5 * (1 - i / nser)),
name: "ser " + (i + 1),
symbolStyle: { strokeWidth: 0 },
symbolMarker: seriesSymbol.value,
symbolSize: symbolSize.value,
}),
);
}
chart.endUpdate();
}
function gesturesInitialized(s) {
gestures.value = s;
}
function resetZoom() {
gestures.value.reset();
}
</script>
<style>
.wj-flexchart {
width: 600px;
height: 500px !important;
margin: 0;
}
</style>
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>WebGL</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- SystemJS -->
<script src="compiler.js" type="module"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.21.5/system.src.js" integrity="sha512-skZbMyvYdNoZfLmiGn5ii6KmklM82rYX2uWctBhzaXPxJgiv4XBwJnFGr5k8s+6tE1pcR1nuTKghozJHyzMcoA==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('./src/app.js');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
export function getData(cx, cy, n, maxr) {
let data = new Array(n);
let r0 = 0.1 + maxr;
for (let i = 0; i < data.length; i++) {
let a = 2 * Math.PI * Math.random();
let r = r0 * Math.sqrt(-2 * Math.log(Math.random()));
data[i] = {
x: cx + r * Math.cos(a),
y: cy + r * Math.sin(a)
};
}
return data;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
meta: {
'*.css': { loader: 'css' },
'*.vue': { loader: '../plugin-vue/index.js' }
//'*.vue': { loader: 'systemjs-plugin-vue' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'@mescius/wijmo': 'npm:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'npm:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'npm:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'npm:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'npm:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'npm:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'npm:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'npm:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'npm:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'npm:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'npm:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'npm:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'npm:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'npm:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'npm:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'npm:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'npm:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'npm:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'npm:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'npm:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'npm:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'npm:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'npm:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'npm:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'npm:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'npm:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'npm:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'npm:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'npm:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'npm:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'npm:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.nav': 'npm:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'npm:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'npm:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'npm:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'npm:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'npm:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'npm:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'npm:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'npm:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'npm:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.touch': 'npm:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'npm:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.barcode': 'npm:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'npm:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'npm:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'npm:@mescius/wijmo.barcode.specialized/index.js',
"@mescius/wijmo.vue2.chart.analytics": "npm:@mescius/wijmo.vue2.chart.analytics/index.js",
"@mescius/wijmo.vue2.chart.animation": "npm:@mescius/wijmo.vue2.chart.animation/index.js",
"@mescius/wijmo.vue2.chart.annotation": "npm:@mescius/wijmo.vue2.chart.annotation/index.js",
"@mescius/wijmo.vue2.chart.finance.analytics": "npm:@mescius/wijmo.vue2.chart.finance.analytics/index.js",
"@mescius/wijmo.vue2.chart.finance": "npm:@mescius/wijmo.vue2.chart.finance/index.js",
"@mescius/wijmo.vue2.chart.hierarchical": "npm:@mescius/wijmo.vue2.chart.hierarchical/index.js",
"@mescius/wijmo.vue2.chart.interaction": "npm:@mescius/wijmo.vue2.chart.interaction/index.js",
"@mescius/wijmo.vue2.chart.radar": "npm:@mescius/wijmo.vue2.chart.radar/index.js",
'@mescius/wijmo.vue2.chart.map': 'npm:@mescius/wijmo.vue2.chart.map/index.js',
"@mescius/wijmo.vue2.chart": "npm:@mescius/wijmo.vue2.chart/index.js",
"@mescius/wijmo.vue2.core": "npm:@mescius/wijmo.vue2.core/index.js",
"@mescius/wijmo.vue2.gauge": "npm:@mescius/wijmo.vue2.gauge/index.js",
"@mescius/wijmo.vue2.grid.detail": "npm:@mescius/wijmo.vue2.grid.detail/index.js",
"@mescius/wijmo.vue2.grid.filter": "npm:@mescius/wijmo.vue2.grid.filter/index.js",
"@mescius/wijmo.vue2.grid.grouppanel": "npm:@mescius/wijmo.vue2.grid.grouppanel/index.js",
'@mescius/wijmo.vue2.grid.search': 'npm:@mescius/wijmo.vue2.grid.search/index.js',
"@mescius/wijmo.vue2.grid.multirow": "npm:@mescius/wijmo.vue2.grid.multirow/index.js",
"@mescius/wijmo.vue2.grid.sheet": "npm:@mescius/wijmo.vue2.grid.sheet/index.js",
'@mescius/wijmo.vue2.grid.transposed': 'npm:@mescius/wijmo.vue2.grid.transposed/index.js',
'@mescius/wijmo.vue2.grid.transposedmultirow': 'npm:@mescius/wijmo.vue2.grid.transposedmultirow/index.js',
"@mescius/wijmo.vue2.grid": "npm:@mescius/wijmo.vue2.grid/index.js",
"@mescius/wijmo.vue2.input": "npm:@mescius/wijmo.vue2.input/index.js",
"@mescius/wijmo.vue2.olap": "npm:@mescius/wijmo.vue2.olap/index.js",
"@mescius/wijmo.vue2.viewer": "npm:@mescius/wijmo.vue2.viewer/index.js",
"@mescius/wijmo.vue2.nav": "npm:@mescius/wijmo.vue2.nav/index.js",
"@mescius/wijmo.vue2.base": "npm:@mescius/wijmo.vue2.base/index.js",
'@mescius/wijmo.vue2.barcode.common': 'npm:@mescius/wijmo.vue2.barcode.common/index.js',
'@mescius/wijmo.vue2.barcode.composite': 'npm:@mescius/wijmo.vue2.barcode.composite/index.js',
'@mescius/wijmo.vue2.barcode.specialized': 'npm:@mescius/wijmo.vue2.barcode.specialized/index.js',
'bootstrap.css': 'npm:bootstrap/dist/css/bootstrap.min.css',
'jszip': 'npm:jszip/dist/jszip.js',
'css': 'npm:systemjs-plugin-css/css.js',
'vue': 'npm:vue/dist/vue.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'vue-loader': 'npm:systemjs-vue-browser/index.js',
//'systemjs-plugin-vue': 'npm:systemjs-plugin-vue/index.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'js'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
wijmo: {
defaultExtension: 'js',
}
}
});
})(this);

import 'bootstrap.css';
import '@mescius/wijmo.styles/wijmo.css';
import './styles.css';
//
import '@angular/compiler';
import { Component, enableProdMode, Inject, ɵresolveComponentResources } from '@angular/core';
import { FormsModule } from '@angular/forms';
import { BrowserModule, bootstrapApplication } from '@angular/platform-browser';
import { WjInputModule } from '@mescius/wijmo.angular2.input';
import { WjChartModule } from '@mescius/wijmo.angular2.chart';
import { WjChartInteractionModule } from '@mescius/wijmo.angular2.chart.interaction';
import { isIE } from '@mescius/wijmo';
import * as wjChart from '@mescius/wijmo.chart';
import { DataService } from './app.data';
import { WebGLRenderEngine } from '@mescius/wijmo.chart.webgl';
//
//
@Component({
standalone: true,
providers: [DataService],
imports: [BrowserModule, FormsModule, WjInputModule, WjChartModule, WjChartInteractionModule],
selector: 'app-component',
templateUrl: 'src/app.component.html',
})
export class AppComponent {
private _numberOfPoints: number = isIE() ? 10000 : 100000;
private _numberOfSeries: number = 1;
private _seriesSymbol: string = 'Dot';
symbolSize: number = 3;
useWebGL: boolean = true;
data: any[] = [];
notIE: boolean = !isIE();
//
private _chart: wjChart.FlexChart;
private _webglEng = new WebGLRenderEngine();
private _svgEng = new wjChart.SvgRenderEngine();
//
constructor(@Inject(DataService) private dataService: DataService) {}
//
get numberOfPoints(): number {
return this._numberOfPoints;
}
set numberOfPoints(value: number) {
this._numberOfPoints = value;
this.updateData();
}
//
get numberOfSeries(): number {
return this._numberOfSeries;
}
set numberOfSeries(value: number) {
this._numberOfSeries = value;
this.updateData();
}
//
get seriesSymbol(): string {
return this._seriesSymbol;
}
set seriesSymbol(value: string) {
this._seriesSymbol = value;
}
//
get renderEngine(): wjChart.IRenderEngine {
return this.useWebGL ? this._webglEng : this._svgEng;
}
//
chartInitialized(chart: wjChart.FlexChart) {
this._chart = chart;
this.updateData();
}
//
updateData() {
if (this._chart) {
const data = [];
const nser = this.numberOfSeries;
const npts = this.numberOfPoints;
for (let i = 0; i < nser; i++) {
data.push(
this.dataService.getData(Math.random() - 0.5, Math.random() - 0.5, npts / nser, 0.5 * (1 - i / nser)),
);
}
this.data = data;
}
}
}
//
//
enableProdMode();
// Resolve resources (templateUrl, styleUrls etc), After resolution all URLs have been converted into `template` strings.
ɵresolveComponentResources(fetch).then(() => {
// Bootstrap application
bootstrapApplication(AppComponent).catch((err) => console.error(err));
});
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>WebGL</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- Polyfills -->
<script src="node_modules/core-js/client/shim.min.js"></script>
<script src="node_modules/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.21.5/system.src.js" integrity="sha512-skZbMyvYdNoZfLmiGn5ii6KmklM82rYX2uWctBhzaXPxJgiv4XBwJnFGr5k8s+6tE1pcR1nuTKghozJHyzMcoA==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<div class='container-fluid'>
<div class="row">
<div class="col-sm-12">
<wj-menu header="NumPoints" [(value)]="numberOfPoints">
<wj-menu-item [value]="1000">1K</wj-menu-item>
<wj-menu-item [value]="10000">10K</wj-menu-item>
<wj-menu-item [value]="100000">100K</wj-menu-item>
<wj-menu-item *ngIf="notIE" [value]="200000">200K</wj-menu-item>
<wj-menu-item *ngIf="notIE" [value]="500000">500K</wj-menu-item>
</wj-menu>
<wj-menu header="NumSeries" [(value)]="numberOfSeries">
<wj-menu-item [value]="1">1</wj-menu-item>
<wj-menu-item [value]="2">2</wj-menu-item>
<wj-menu-item [value]="4">4</wj-menu-item>
<wj-menu-item [value]="8">8</wj-menu-item>
</wj-menu>
<wj-menu header="Symbol" [(value)]="seriesSymbol">
<wj-menu-item [value]="'Dot'">Dot</wj-menu-item>
<wj-menu-item [value]="'Box'">Box</wj-menu-item>
</wj-menu>
<wj-menu header="Size" [(value)]="symbolSize">
<wj-menu-item [value]="3">3</wj-menu-item>
<wj-menu-item [value]="5">5</wj-menu-item>
<wj-menu-item [value]="10">10</wj-menu-item>
<wj-menu-item [value]="20">20</wj-menu-item>
<wj-menu-item [value]="50">50</wj-menu-item>
</wj-menu>
<label>
Use WebGL
<input id="webgl" type="checkbox" [(ngModel)]="useWebGL" />
</label>
</div>
</div>
<div class="row">
<div class="col-sm-12">
<wj-flex-chart #chart [renderEngine]="renderEngine" chartType="Scatter" bindingX="x" binding="y"
[symbolSize]="symbolSize" (initialized)="chartInitialized(chart)" >
<wj-flex-chart-axis wjProperty="axisX" [min]="-2" [max]="2"></wj-flex-chart-axis>
<wj-flex-chart-axis wjProperty="axisY" [min]="-2" [max]="2" [axisLine]="true" [majorGrid]="false"></wj-flex-chart-axis>
<wj-flex-chart-gestures #gestures interactiveAxes="XY" mouseAction="Zoom"
[scaleY]="1" [posY]="0.5" [scaleX]="1" [posX]="0.5"></wj-flex-chart-gestures>
<wj-flex-chart-series *ngFor="let series of data; let i = index" [itemsSource]="series"
[name]="'ser ' + (i + 1)" [symbolStyle] = "{strokeWidth: 0}"
[symbolMarker]="seriesSymbol"></wj-flex-chart-series>
</wj-flex-chart>
</div>
</div>
<div class="row">
<div class="col-sm-12">
<button id="btnNew" (click)="updateData()">Refresh Data</button>
<button id="btnReset" (click)="gestures.reset()">Reset Zoom</button>
</div>
</div>
</div>
import { Injectable } from '@angular/core';
//
@Injectable()
export class DataService {
getData(cx: number, cy: number, n: number, maxr: number) {
let data = new Array(n);
let r0 = 0.1 + maxr;
for (let i = 0; i < data.length; i++) {
let a = 2 * Math.PI * Math.random();
let r = r0 * Math.sqrt(-2 * Math.log(Math.random()));
data[i] = {
x: cx + r * Math.cos(a),
y: cy + r * Math.sin(a)
};
}
return data;
}
}
.wj-flexchart {
width: 600px;
height: 500px;
margin: 0;
}
(function (global) {
SystemJS.config({
transpiler: './plugin-typescript.js',
typescriptOptions: {
"target": "ES2022",
"module": "system",
"emitDecoratorMetadata": true,
"experimentalDecorators": true,
},
baseURL: 'node_modules/',
meta: {
'typescript': {
"exports": "ts"
},
'*.css': { loader: 'systemjs-plugin-css' },
'*.mjs': {
format: 'esm'
},
},
paths: {
// paths serve as alias
'npm:': ''
},
packageConfigPaths: [
'/node_modules/*/package.json',
"/node_modules/@angular/*/package.json",
"/node_modules/@mescius/*/package.json"
],
map: {
'core-js': 'https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js',
'typescript': 'https://cdnjs.cloudflare.com/ajax/libs/typescript/5.2.2/typescript.min.js',
"rxjs": "https://cdnjs.cloudflare.com/ajax/libs/rxjs/7.8.1/rxjs.umd.min.js",
'systemjs-plugin-css': 'https://cdn.jsdelivr.net/npm/systemjs-plugin-css@0.1.37/css.js',
'@mescius/wijmo': 'npm:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'npm:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'npm:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'npm:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'npm:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'npm:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'npm:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'npm:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'npm:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'npm:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'npm:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'npm:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'npm:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'npm:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'npm:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'npm:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'npm:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'npm:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'npm:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'npm:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'npm:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'npm:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'npm:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'npm:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'npm:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'npm:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'npm:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'npm:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'npm:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'npm:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'npm:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.nav': 'npm:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'npm:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'npm:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'npm:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'npm:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'npm:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'npm:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'npm:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'npm:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'npm:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.touch': 'npm:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'npm:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.barcode': 'npm:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'npm:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'npm:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'npm:@mescius/wijmo.barcode.specialized/index.js',
"@mescius/wijmo.angular2.chart.analytics": "npm:@mescius/wijmo.angular2.chart.analytics/index.js",
"@mescius/wijmo.angular2.chart.animation": "npm:@mescius/wijmo.angular2.chart.animation/index.js",
"@mescius/wijmo.angular2.chart.annotation": "npm:@mescius/wijmo.angular2.chart.annotation/index.js",
"@mescius/wijmo.angular2.chart.finance.analytics": "npm:@mescius/wijmo.angular2.chart.finance.analytics/index.js",
"@mescius/wijmo.angular2.chart.finance": "npm:@mescius/wijmo.angular2.chart.finance/index.js",
"@mescius/wijmo.angular2.chart.hierarchical": "npm:@mescius/wijmo.angular2.chart.hierarchical/index.js",
"@mescius/wijmo.angular2.chart.interaction": "npm:@mescius/wijmo.angular2.chart.interaction/index.js",
"@mescius/wijmo.angular2.chart.radar": "npm:@mescius/wijmo.angular2.chart.radar/index.js",
'@mescius/wijmo.angular2.chart.map': 'npm:@mescius/wijmo.angular2.chart.map/index.js',
"@mescius/wijmo.angular2.chart": "npm:@mescius/wijmo.angular2.chart/index.js",
"@mescius/wijmo.angular2.core": "npm:@mescius/wijmo.angular2.core/index.js",
"@mescius/wijmo.angular2.gauge": "npm:@mescius/wijmo.angular2.gauge/index.js",
"@mescius/wijmo.angular2.grid.detail": "npm:@mescius/wijmo.angular2.grid.detail/index.js",
"@mescius/wijmo.angular2.grid.filter": "npm:@mescius/wijmo.angular2.grid.filter/index.js",
"@mescius/wijmo.angular2.grid.grouppanel": "npm:@mescius/wijmo.angular2.grid.grouppanel/index.js",
"@mescius/wijmo.angular2.grid.search": "npm:@mescius/wijmo.angular2.grid.search/index.js",
"@mescius/wijmo.angular2.grid.multirow": "npm:@mescius/wijmo.angular2.grid.multirow/index.js",
"@mescius/wijmo.angular2.grid.sheet": "npm:@mescius/wijmo.angular2.grid.sheet/index.js",
'@mescius/wijmo.angular2.grid.transposed': 'npm:@mescius/wijmo.angular2.grid.transposed/index.js',
'@mescius/wijmo.angular2.grid.transposedmultirow': 'npm:@mescius/wijmo.angular2.grid.transposedmultirow/index.js',
"@mescius/wijmo.angular2.grid": "npm:@mescius/wijmo.angular2.grid/index.js",
"@mescius/wijmo.angular2.input": "npm:@mescius/wijmo.angular2.input/index.js",
"@mescius/wijmo.angular2.olap": "npm:@mescius/wijmo.angular2.olap/index.js",
"@mescius/wijmo.angular2.viewer": "npm:@mescius/wijmo.angular2.viewer/index.js",
"@mescius/wijmo.angular2.nav": "npm:@mescius/wijmo.angular2.nav/index.js",
"@mescius/wijmo.angular2.directivebase": "npm:@mescius/wijmo.angular2.directivebase/index.js",
'@mescius/wijmo.angular2.barcode.common': 'npm:@mescius/wijmo.angular2.barcode.common/index.js',
'@mescius/wijmo.angular2.barcode.composite': 'npm:@mescius/wijmo.angular2.barcode.composite/index.js',
'@mescius/wijmo.angular2.barcode.specialized': 'npm:@mescius/wijmo.angular2.barcode.specialized/index.js',
'bootstrap.css': 'npm:bootstrap/dist/css/bootstrap.min.css',
'jszip': 'https://cdnjs.cloudflare.com/ajax/libs/jszip/3.10.1/jszip.min.js',
'@angular/core': 'npm:@angular/core/fesm2022/core.mjs',
'@angular/core/primitives/signals': 'npm:@angular/core/fesm2022/primitives/signals.mjs',
'@angular/core/primitives/event-dispatch': 'npm:@angular/core/fesm2022/primitives/event-dispatch.mjs',
'@angular/common': 'npm:@angular/common/fesm2022/common.mjs',
'@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs',
'@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs',
'@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs',
'@angular/http': 'npm:@angular/http/fesm2022/http.mjs',
'@angular/router': 'npm:@angular/router/fesm2022/router.mjs',
'@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs',
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
"./src": {
defaultExtension: 'ts'
},
"node_modules": {
defaultExtension: 'js'
},
wijmo: {
defaultExtension: 'js',
}
}
});
})(this);

import 'bootstrap.css';
import '@mescius/wijmo.styles/wijmo.css';
import ReactDOM from 'react-dom/client';
import React, { useEffect, useRef, useState } from 'react';
import useEvent from 'react-use-event-hook';
import { isIE } from '@mescius/wijmo';
import * as wjChart from '@mescius/wijmo.chart';
import { WebGLRenderEngine } from '@mescius/wijmo.chart.webgl';
import { Menu, MenuItem } from '@mescius/wijmo.react.input';
import { FlexChart, FlexChartAxis, FlexChartSeries } from '@mescius/wijmo.react.chart';
import { FlexChartGestures } from '@mescius/wijmo.react.chart.interaction';
import './app.css';
import { getData } from './data';
function App() {
const [numberOfPoints, setNumberOfPoints] = useState(isIE() ? 10000 : 100000);
const [numberOfSeries, setNumberOfSeries] = useState(1);
const [seriesSymbol, setSeriesSymbol] = useState('Dot');
const [symbolSize, setSymbolSize] = useState(3);
const [useWebGL, setUseWebGL] = useState(true);
const [data, setData] = useState([]);
const gesturesRef = useRef(null);
const webglEngRef = useRef(new WebGLRenderEngine());
const svgEngRef = useRef(new wjChart.SvgRenderEngine());
const renderEngine = () => {
return useWebGL ? webglEngRef.current : svgEngRef.current;
};
const gesturesInitialized = useEvent((s) => {
gesturesRef.current = s;
});
const numPointsChanged = useEvent((s) => {
setNumberOfPoints(s.selectedValue);
});
const numSeriesChanged = useEvent((s) => {
setNumberOfSeries(s.selectedValue);
});
const symbolChanged = useEvent((s) => {
setSeriesSymbol(s.selectedValue);
});
const sizeChanged = useEvent((s) => {
setSymbolSize(s.selectedValue);
});
const engineChanged = useEvent((e) => {
setUseWebGL(e.target.checked);
});
const resetZoom = useEvent(() => {
var _a;
(_a = gesturesRef.current) === null || _a === void 0 ? void 0 : _a.reset();
});
const refreshData = () => {
const data = [];
for (let i = 0; i < numberOfSeries; i++) {
data.push(getData(Math.random() - 0.5, Math.random() - 0.5, numberOfPoints / numberOfSeries, 0.5 * (1 - i / numberOfSeries)));
}
setData(data);
};
useEffect(() => {
refreshData();
}, [numberOfSeries, numberOfPoints]);
return (<div className="container-fluid">
<div className="row">
<div className="col-sm-12">
<Menu header="NumPoints" value={numberOfPoints} itemClicked={numPointsChanged}>
<MenuItem value={1000}>1K</MenuItem>
<MenuItem value={10000}>10K</MenuItem>
<MenuItem value={100000}>100K</MenuItem>
{!isIE() && <MenuItem value={200000}>200K</MenuItem>}
{!isIE() && <MenuItem value={500000}>500K</MenuItem>}
</Menu>
<Menu header="NumSeries" value={numberOfSeries} itemClicked={numSeriesChanged}>
<MenuItem value={1}>1</MenuItem>
<MenuItem value={2}>2</MenuItem>
<MenuItem value={4}>4</MenuItem>
<MenuItem value={8}>8</MenuItem>
</Menu>
<Menu header="Symbol" value={seriesSymbol} itemClicked={symbolChanged}>
<MenuItem value="Dot">Dot</MenuItem>
<MenuItem value="Box">Box</MenuItem>
</Menu>
<Menu header="Size" value={symbolSize} itemClicked={sizeChanged}>
<MenuItem value={3}>3</MenuItem>
<MenuItem value={5}>5</MenuItem>
<MenuItem value={10}>10</MenuItem>
<MenuItem value={20}>20</MenuItem>
<MenuItem value={50}>50</MenuItem>
</Menu>
<label>
Use WebGL
<input id="webgl" type="checkbox" checked={useWebGL} onChange={engineChanged}/>
</label>
</div>
</div>
<div className="row">
<div className="col-sm-12">
<FlexChart renderEngine={renderEngine()} chartType="Scatter" bindingX="x" binding="y" symbolSize={symbolSize}>
<FlexChartAxis wjProperty="axisX" min={-2} max={2}/>
<FlexChartAxis wjProperty="axisY" min={-2} max={2} axisLine majorGrid={false}/>
<FlexChartGestures interactiveAxes="XY" mouseAction="Zoom" initialized={gesturesInitialized} scaleY={1} posY={0.5} scaleX={1} posX={0.5}/>
{data.map((series, i) => {
return (<FlexChartSeries key={i} itemsSource={series} name={`ser ${i + 1}`} symbolStyle={{ strokeWidth: 0 }} symbolMarker={seriesSymbol}/>);
})}
</FlexChart>
</div>
</div>
<div className="row">
<div className="col-sm-12">
<button id="btnNew" onClick={refreshData}>Refresh Data</button>
<button id="btnReset" onClick={resetZoom}>Reset Zoom</button>
</div>
</div>
</div>);
}
const container = document.getElementById('app');
if (container) {
const root = ReactDOM.createRoot(container);
root.render(<App />);
}
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>WebGL</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- SystemJS -->
<script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.40/system.src.js" integrity="sha512-G6mEj6h18+m3MvzdviSDfPle/TfH0//cXcB33AKlNR/Rha0yQsKefDZKRTkIZos97HEGq2JMV1RT5ybMoQ3WsQ==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('./src/app');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
.wj-flexchart {
width: 600px;
height: 500px;
margin: 0;
}
export function getData(cx, cy, n, maxr) {
let data = new Array(n);
let r0 = 0.1 + maxr;
for (let i = 0; i < data.length; i++) {
let a = 2 * Math.PI * Math.random();
let r = r0 * Math.sqrt(-2 * Math.log(Math.random()));
data[i] = {
x: cx + r * Math.cos(a),
y: cy + r * Math.sin(a)
};
}
return data;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'jszip': 'npm:jszip/dist/jszip.js',
'@mescius/wijmo': 'npm:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'npm:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'npm:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'npm:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'npm:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'npm:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'npm:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'npm:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'npm:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'npm:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'npm:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'npm:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'npm:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'npm:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'npm:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'npm:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'npm:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'npm:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'npm:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'npm:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'npm:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'npm:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'npm:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'npm:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'npm:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'npm:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'npm:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'npm:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'npm:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'npm:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'npm:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.grid.immutable': 'npm:@mescius/wijmo.grid.immutable/index.js',
'@mescius/wijmo.touch': 'npm:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'npm:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.nav': 'npm:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'npm:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'npm:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'npm:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'npm:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'npm:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'npm:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'npm:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'npm:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'npm:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.barcode': 'npm:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'npm:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'npm:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'npm:@mescius/wijmo.barcode.specialized/index.js',
"@mescius/wijmo.react.chart.analytics": "npm:@mescius/wijmo.react.chart.analytics/index.js",
"@mescius/wijmo.react.chart.animation": "npm:@mescius/wijmo.react.chart.animation/index.js",
"@mescius/wijmo.react.chart.annotation": "npm:@mescius/wijmo.react.chart.annotation/index.js",
"@mescius/wijmo.react.chart.finance.analytics": "npm:@mescius/wijmo.react.chart.finance.analytics/index.js",
"@mescius/wijmo.react.chart.finance": "npm:@mescius/wijmo.react.chart.finance/index.js",
"@mescius/wijmo.react.chart.hierarchical": "npm:@mescius/wijmo.react.chart.hierarchical/index.js",
"@mescius/wijmo.react.chart.interaction": "npm:@mescius/wijmo.react.chart.interaction/index.js",
"@mescius/wijmo.react.chart.radar": "npm:@mescius/wijmo.react.chart.radar/index.js",
"@mescius/wijmo.react.chart": "npm:@mescius/wijmo.react.chart/index.js",
"@mescius/wijmo.react.core": "npm:@mescius/wijmo.react.core/index.js",
'@mescius/wijmo.react.chart.map': 'npm:@mescius/wijmo.react.chart.map/index.js',
"@mescius/wijmo.react.gauge": "npm:@mescius/wijmo.react.gauge/index.js",
"@mescius/wijmo.react.grid.detail": "npm:@mescius/wijmo.react.grid.detail/index.js",
"@mescius/wijmo.react.grid.filter": "npm:@mescius/wijmo.react.grid.filter/index.js",
"@mescius/wijmo.react.grid.grouppanel": "npm:@mescius/wijmo.react.grid.grouppanel/index.js",
'@mescius/wijmo.react.grid.search': 'npm:@mescius/wijmo.react.grid.search/index.js',
"@mescius/wijmo.react.grid.multirow": "npm:@mescius/wijmo.react.grid.multirow/index.js",
"@mescius/wijmo.react.grid.sheet": "npm:@mescius/wijmo.react.grid.sheet/index.js",
'@mescius/wijmo.react.grid.transposed': 'npm:@mescius/wijmo.react.grid.transposed/index.js',
'@mescius/wijmo.react.grid.transposedmultirow': 'npm:@mescius/wijmo.react.grid.transposedmultirow/index.js',
'@mescius/wijmo.react.grid.immutable': 'npm:@mescius/wijmo.react.grid.immutable/index.js',
"@mescius/wijmo.react.grid": "npm:@mescius/wijmo.react.grid/index.js",
"@mescius/wijmo.react.input": "npm:@mescius/wijmo.react.input/index.js",
"@mescius/wijmo.react.olap": "npm:@mescius/wijmo.react.olap/index.js",
"@mescius/wijmo.react.viewer": "npm:@mescius/wijmo.react.viewer/index.js",
"@mescius/wijmo.react.nav": "npm:@mescius/wijmo.react.nav/index.js",
"@mescius/wijmo.react.base": "npm:@mescius/wijmo.react.base/index.js",
'@mescius/wijmo.react.barcode.common': 'npm:@mescius/wijmo.react.barcode.common/index.js',
'@mescius/wijmo.react.barcode.composite': 'npm:@mescius/wijmo.react.barcode.composite/index.js',
'@mescius/wijmo.react.barcode.specialized': 'npm:@mescius/wijmo.react.barcode.specialized/index.js',
'jszip': 'npm:jszip/dist/jszip.js',
'react': 'npm:react/umd/react.production.min.js',
'react-dom': 'npm:react-dom/umd/react-dom.production.min.js',
'react-dom/client': 'npm:react-dom/umd/react-dom.production.min.js',
'redux': 'npm:redux/dist/redux.min.js',
'react-redux': 'npm:react-redux/dist/react-redux.min.js',
'bootstrap.css': 'npm:bootstrap/dist/css/bootstrap.min.css',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js',
"react-use-event-hook": "npm:react-use-event-hook/dist/esm/useEvent.js",
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);